*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/ggbus.c
***************
*** 0 ****
--- 1,261 ----
+ /*	$NetBSD: ggbus.c,v 1.1 1994/07/08 23:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994, 1995 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Niklas Hallqvist.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #include <sys/param.h>
+ #include <sys/device.h>
+ #include <sys/kernel.h>
+ #include <sys/malloc.h>
+ #include <sys/syslog.h>
+ 
+ #include <machine/cpu.h>
+ #include <machine/pio.h>
+ 
+ #include <dev/isa/isavar.h>
+ 
+ #include <amiga/amiga/custom.h>
+ #include <amiga/amiga/device.h>
+ #include <amiga/amiga/isr.h>
+ #include <amiga/dev/zbusvar.h>
+ #include <amiga/isa/isa_machdep.h>
+ #include <amiga/isa/isa_intr.h>
+ #include <amiga/isa/ggbusvar.h>
+ #include <amiga/isa/ggbusreg.h>
+ 
+ int ggdebug = 0;
+ int ggstrayints = 0;
+ 
+ /* This is OK because we only allow one ISA bus.  */
+ struct ggbus_device *ggbusp;
+ 
+ void	ggbusattach __P((struct device *, struct device *, void *));
+ int	ggbusmatch __P((struct device *, void *, void *));
+ int	ggbusprint __P((void *auxp, char *));
+ void	ggbusstb __P((struct device *, int, u_char));
+ u_char	ggbusldb __P((struct device *, int));
+ void	ggbusstw __P((struct device *, int, u_short));
+ u_short ggbusldw __P((struct device *, int));
+ void	*ggbus_establish_intr __P((int intr, isa_intrtype type,
+ 				   isa_intrlevel level,
+ 				   int (*ih_fun) (void *), void *));
+ void	ggbus_disestablish_intr __P((void *handler));
+ 
+ struct isa_intr_fcns ggbus_intr_fcns = {
+ 	0 /* ggbus_intr_setup */,	ggbus_establish_intr,
+ 	ggbus_disestablish_intr,	0 /* ggbus_iointr */
+ };
+ 
+ struct cfdriver ggbuscd = {
+ 	NULL, "ggbus", ggbusmatch, ggbusattach, 
+ 	DV_DULL, sizeof(struct ggbus_device), 0
+ };
+ 
+ int
+ ggbusmatch(parent, match, aux)
+ 	struct device *parent;
+ 	void *match, *aux;
+ {
+ 	struct zbus_args *zap = aux;
+ 
+ 	/*
+ 	 * Check manufacturer and product id.
+ 	 */
+ 	if (zap->manid == 2150 && zap->prodid == 1)
+ 		return(1);
+ 	return(0);
+ }
+ 
+ void
+ ggbusattach(pdp, dp, auxp)
+ 	struct device *pdp, *dp;
+ 	void *auxp;
+ {
+ 	struct zbus_args *zap = auxp;
+ 	struct ggbus_device *gdp = (struct ggbus_device *)dp;
+ 
+ 	ggbusp = gdp;
+ 	bcopy(zap, &gdp->gd_zargs, sizeof(struct zbus_args));
+ 	gdp->gd_link.il_dev = dp;
+ 	if (gdp->gd_zargs.serno >= 2)
+ 	  {
+ 	    gdp->gd_link.il_ldb = ggbusldb;
+ 	    gdp->gd_link.il_stb = ggbusstb;
+ 	    gdp->gd_link.il_ldw = ggbusldw;
+ 	    gdp->gd_link.il_stw = ggbusstw;
+ 	  }
+ 	else
+ 	  {
+ 	    gdp->gd_link.il_ldb = 0;
+ 	    gdp->gd_link.il_stb = 0;
+ 	    gdp->gd_link.il_ldw = 0;
+ 	    gdp->gd_link.il_stw = 0;
+ 	  }
+ 	gdp->gd_imask = 0;
+ 
+ 	isa_intr_fcns = &ggbus_intr_fcns;
+ 	isa_pio_fcns = &ggbus_pio_fcns;
+ 
+ 	if (gdp->gd_zargs.serno >= 2)
+ 	  {
+ 	    /* XXX turn on wait states unconditionally for now. */
+ 	    GG2_ENABLE_WAIT(zap->va);
+ 	    GG2_ENABLE_INTS(zap->va);
+ 	  }
+ 
+ 	printf(": pa 0x%08x va 0x%08x size 0x%x\n", zap->pa, zap->va, zap->size);
+ 
+ 	/*
+ 	 * attempt to configure the board.
+ 	 */
+ 	config_found(dp, &gdp->gd_link, ggbusprint);
+ }
+ 
+ int
+ ggbusprint(auxp, pnp)
+ 	void *auxp;
+ 	char *pnp;
+ {
+ 	if (pnp == NULL)
+ 		return(QUIET);
+ 	return(UNCONF);
+ }
+ 
+ 
+ void
+ ggbusstb(dev, ia, b)
+ 	struct device *dev;
+ 	int ia;
+ 	u_char b;
+ {
+ 	struct ggbus_device *gd = (struct ggbus_device *)dev;
+ 
+ 	*(volatile u_char *)(gd->gd_zargs.va + GG2_MEMORY_OFFSET + 2 * ia + 1) = b;
+ }
+ 
+ u_char
+ ggbusldb(dev, ia)
+ 	struct device *dev;
+ 	int ia;
+ {
+ 	struct ggbus_device *gd = (struct ggbus_device *)dev;
+ 	u_char retval =
+ 	    *(volatile u_char *)(gd->gd_zargs.va + GG2_MEMORY_OFFSET + 2 * ia + 1);
+ 
+ #ifdef DEBUG
+ 	if (ggdebug)
+ 		printf("ldb 0x%x => 0x%x\n", ia, retval);
+ #endif
+ 	return retval;
+ }
+ 
+ void
+ ggbusstw(dev, ia, w)
+ 	struct device *dev;
+ 	int ia;
+ 	u_short w;
+ {
+ 	struct ggbus_device *gd = (struct ggbus_device *)dev;
+ 
+ 	*(volatile u_short *)(gd->gd_zargs.va + GG2_MEMORY_OFFSET + 2 * ia) = swap(w);
+ }
+ 
+ u_short
+ ggbusldw(dev, ia)
+ 	struct device *dev;
+ 	int ia;
+ {
+ 	struct ggbus_device *gd = (struct ggbus_device *)dev;
+ 	u_short retval =
+ 	    swap(*(volatile u_short *)(gd->gd_zargs.va + GG2_MEMORY_OFFSET + 2 * ia));
+ 
+ #ifdef DEBUG
+ 	if (ggdebug)
+ 		printf("ldw 0x%x => 0x%x\n", ia, retval);
+ #endif
+ 	return retval;
+ }
+ 
+ static ggbus_int_map[] = {
+     0, 0, 0, 0, GG2_IRQ3, GG2_IRQ4, GG2_IRQ5, GG2_IRQ6, GG2_IRQ7, 0,
+     GG2_IRQ9, GG2_IRQ10, GG2_IRQ11, GG2_IRQ12, 0, GG2_IRQ14, GG2_IRQ15
+ };
+ 
+ struct ggintr_desc {
+ 	struct	isr gid_isr;
+ 	int	gid_mask;
+ 	int	(*gid_fun)(void *);
+ 	void	*gid_arg;
+ };
+ 
+ static struct ggintr_desc *ggid[16];	/* XXX */
+ 
+ int
+ ggbusintr(gid)
+ 	struct ggintr_desc *gid;
+ {
+ 	return (GG2_GET_STATUS (ggbusp->gd_zargs.va) & gid->gid_mask) ?
+ 	    (*gid->gid_fun)(gid->gid_arg) : 0;
+ }
+ 
+ void *
+ ggbus_establish_intr(intr, type, level, ih_fun, ih_arg)
+ 	int intr;
+ 	isa_intrtype type;
+ 	isa_intrlevel level;
+ 	int (*ih_fun)(void *);
+ 	void *ih_arg;
+ {
+ 	if (ggid[intr]) {
+ 		log(LOG_WARNING, "ISA interrupt %d already handled\n", intr);
+ 		return 0;
+ 	}
+ 	MALLOC(ggid[intr], struct ggintr_desc *, sizeof(struct ggintr_desc),
+ 	    M_DEVBUF, M_WAITOK);
+ 	ggid[intr]->gid_isr.isr_intr = ggbusintr;
+ 	ggid[intr]->gid_isr.isr_arg = ggid[intr];
+ 	ggid[intr]->gid_isr.isr_ipl = 6;
+ 	ggid[intr]->gid_isr.isr_mapped_ipl = level;
+ 	ggid[intr]->gid_mask = 1 << ggbus_int_map[intr + 1];
+ 	ggid[intr]->gid_fun = ih_fun;
+ 	ggid[intr]->gid_arg = ih_arg;
+ 	add_isr(&ggid[intr]->gid_isr);
+ 	return &ggid[intr];
+ }
+ 
+ void
+ ggbus_disestablish_intr(handler)
+ 	void  *handler;
+ {
+ 	struct ggintr_desc **gid = handler;
+ 
+ 	remove_isr(&(*gid)->gid_isr);
+ 	FREE(*gid, M_DEVBUF);
+ 	*gid = 0;
+ }
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/ggbus_pio.c
***************
*** 0 ****
--- 1,114 ----
+ /*	$NetBSD: ggbus_pio.c,v 1.1 1995/08/04 14:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1995 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Niklas Hallqvist.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #include <sys/types.h>
+ #include <sys/device.h>
+ 
+ #include <machine/pio.h>
+ 
+ #include <dev/isa/isavar.h>
+ 
+ #include <amiga/amiga/isr.h>
+ #include <amiga/dev/zbusvar.h>
+ #include <amiga/isa/isa_machdep.h>
+ #include <amiga/isa/ggbusreg.h>
+ #include <amiga/isa/ggbusvar.h>
+ 
+ extern struct ggbus_device *ggbusp;
+ 
+ void		ggbus_outb __P((int, u_int8_t));
+ u_int8_t	ggbus_inb __P((int));
+ void		ggbus_outw __P((int, u_int16_t));
+ u_int16_t	ggbus_inw __P((int));
+ 
+ struct isa_pio_fcns ggbus_pio_fcns = {
+ 	ggbus_inb,	isa_insb,
+ 	ggbus_inw,	isa_insw,
+ 	0 /* ggbus_inl */,	0 /* ggbus_insl */,
+ 	ggbus_outb,	isa_outsb,
+ 	ggbus_outw,	isa_outsw,
+ 	0 /* ggbus_outl */,	0 /* ggbus_outsl */,
+ };
+ 
+ void
+ ggbus_outb(ia, b)
+ 	int ia;
+ 	u_int8_t b;
+ {
+ #ifdef DEBUG
+ 	if (ggdebug)
+ 		printf("outb 0x%x,0x%x\n", ia, b);
+ #endif
+ 	*(volatile u_int8_t *)(ggbusp->gd_zargs.va + 2 * ia + 1) = b;
+ }
+ 
+ u_int8_t
+ ggbus_inb(ia)
+ 	int ia;
+ {
+ 	u_int8_t retval =
+ 	    *(volatile u_int8_t *)(ggbusp->gd_zargs.va + 2 * ia + 1);
+ 
+ 
+ #ifdef DEBUG
+ 	if (ggdebug)
+ 		printf("inb 0x%x => 0x%x\n", ia, retval);
+ #endif
+ 	return retval;
+ }
+ 
+ void
+ ggbus_outw(ia, w)
+ 	int ia;
+ 	u_int16_t w;
+ {
+ #ifdef DEBUG
+ 	if (ggdebug)
+ 		printf("outw 0x%x,0x%x\n", ia, w);
+ #endif
+ 	*(volatile u_int16_t *)(ggbusp->gd_zargs.va + 2 * ia) = swap (w);
+ }
+ 
+ u_int16_t
+ ggbus_inw(ia)
+ 	int ia;
+ {
+ 	u_int16_t retval =
+             swap(*(volatile u_int16_t *)(ggbusp->gd_zargs.va + 2 * ia));
+ 
+ 
+ #ifdef DEBUG
+ 	if (ggdebug)
+ 		printf("inw 0x%x => 0x%x\n", ia, retval);
+ #endif
+ 	return retval;
+ }
+ 
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/ggbusreg.h
***************
*** 0 ****
--- 1,67 ----
+ /*	$NetBSD: ggbusreg.h,v 1.1 1994/07/08 23:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Niklas Hallqvist.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #ifndef _GGBUSREG_H_
+ #define _GGBUSREG_H_
+ 
+ #define GG2_MEMORY_OFFSET (0x20000 - 2 * 0x90000)
+ 
+ #define GG2_STATUS 0x18000
+ #define GG2_GET_STATUS(va) (*(volatile u_short *)((va) + GG2_STATUS))
+ 
+ #define GG2_MASTER 0
+ #define GG2_WAIT 1
+ #define GG2_IRQ3 2
+ #define GG2_IRQ4 3
+ #define GG2_IRQ5 4
+ #define GG2_IRQ6 5
+ #define GG2_IRQ7 6
+ #define GG2_IRQ9 7
+ #define GG2_IRQ10 8
+ #define GG2_IRQ11 9
+ #define GG2_IRQ12 10
+ #define GG2_IRQ14 11
+ #define GG2_IRQ15 12
+ #define GG2_IRQ_MASK 0x1ffc
+ #define GG2_GET_INT_STATUS(va) (GG2_GET_STATUS(va) & GG2_IRQ_MASK)
+ 
+ #define GG2_INT_CTRL 0x18002
+ #define GG2_DISABLE_INTS(va) (*(volatile u_short *)((va) + GG2_INT_CTRL))
+ #define GG2_ENABLE_INTS(va) (*(volatile u_short *)((va) + GG2_INT_CTRL) = 0)
+ 
+ #define GG2_WAIT_CTRL 0x18004
+ #define GG2_TOGGLE_WAIT(va) (*(volatile u_char *)((va) + GG2_WAIT_CTRL))
+ #define GG2_ENABLE_WAIT(va) \
+     while ((GG2_GET_STATUS(va) & 1 << GG2_WAIT) == 0) GG2_TOGGLE_WAIT(va)
+ #define GG2_DISABLE_WAIT(va) \
+     while (GG2_GET_STATUS(va) & 1 << GG2_WAIT) GG2_TOGGLE_WAIT(va)
+ 
+ #endif
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/ggbusvar.h
***************
*** 0 ****
--- 1,50 ----
+ /*	$NetBSD: ggbusvar.h,v 1.1 1994/07/08 23:32:17 niklas Exp $	*/
+ 
+ /*
+  * Copyright (c) 1994, 1995 Niklas Hallqvist
+  * All rights reserved.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *      This product includes software developed by Niklas Hallqvist.
+  * 4. The name of the author may not be used to endorse or promote products
+  *    derived from this software without specific prior written permission
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+  * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+  * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+  * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+  * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+  * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+  * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+  */
+ #ifndef _GGBUSVAR_H_
+ #define _GGBUSVAR_H_
+ 
+ struct ggbus_device {
+ 	struct	device gd_dev;
+ 	struct	zbus_args gd_zargs;
+ 	struct	isa_link gd_link;
+ 	int	(*gd_ifunc[16])();
+ 	void	*gd_iarg[16];
+ 	int	gd_ipri[16];
+ 	int	gd_imask;
+ 	struct	isr gd_isr;
+ };
+ 
+ extern int ggdebug;
+ 
+ #endif
+ 
+ 
*** /dev/null
--- NetBSD/src/sys/arch/amiga/isa/icu.h
***************
*** 0 ****
--- 1,97 ----
+ /*-
+  * Copyright (c) 1990 The Regents of the University of California.
+  * All rights reserved.
+  *
+  * This code is derived from software contributed to Berkeley by
+  * William Jolitz.
+  *
+  * Redistribution and use in source and binary forms, with or without
+  * modification, are permitted provided that the following conditions
+  * are met:
+  * 1. Redistributions of source code must retain the above copyright
+  *    notice, this list of conditions and the following disclaimer.
+  * 2. Redistributions in binary form must reproduce the above copyright
+  *    notice, this list of conditions and the following disclaimer in the
+  *    documentation and/or other materials provided with the distribution.
+  * 3. All advertising materials mentioning features or use of this software
+  *    must display the following acknowledgement:
+  *	This product includes software developed by the University of
+  *	California, Berkeley and its contributors.
+  * 4. Neither the name of the University nor the names of its contributors
+  *    may be used to endorse or promote products derived from this software
+  *    without specific prior written permission.
+  *
+  * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+  * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+  * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+  * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+  * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+  * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+  * SUCH DAMAGE.
+  *
+  *	from: @(#)icu.h	5.6 (Berkeley) 5/9/91
+  *	$Id$
+  */
+ 
+ /*
+  * AT/386 Interrupt Control constants
+  * W. Jolitz 8/89
+  */
+ 
+ #ifndef	__ICU__
+ #define	__ICU__
+ 
+ #ifndef	LOCORE
+ 
+ /*
+  * Interrupt "level" mechanism variables, masks, and macros
+  */
+ extern	unsigned imen;		/* interrupt mask enable */
+ 
+ #define	INTREN(s)	do{imen &= ~(s); SET_ICUS();}while(0)
+ #define	INTRDIS(s)	do{imen |= (s); SET_ICUS();}while(0)
+ #define	INTRMASK(msk,s)	(msk |= (s))
+ #if 0
+ #define SET_ICUS()	do{outb(IO_ICU1 + 1, imen); outb(IU_ICU2 + 1, imen >> 8);}while(0)
+ #else
+ /*
+  * XXX - IO_ICU* are defined in isa.h, not icu.h, and nothing much bothers to
+  * include isa.h, while too many things include icu.h.
+  */
+ #define SET_ICUS()	do{outb(0x21, imen); outb(0xa1, imen >> 8);}while(0)
+ #endif
+ 
+ #endif
+ 
+ /*
+  * Interrupt enable bits -- in order of priority
+  */
+ #define	IRQ0		0x0001		/* highest priority - timer */
+ #define	IRQ1		0x0002
+ #define	IRQ_SLAVE	0x0004
+ #define	IRQ8		0x0100
+ #define	IRQ9		0x0200
+ #define	IRQ2		IRQ9
+ #define	IRQ10		0x0400
+ #define	IRQ11		0x0800
+ #define	IRQ12		0x1000
+ #define	IRQ13		0x2000
+ #define	IRQ14		0x4000
+ #define	IRQ15		0x8000
+ #define	IRQ3		0x0008
+ #define	IRQ4		0x0010
+ #define	IRQ5		0x0020
+ #define	IRQ6		0x0040
+ #define	IRQ7		0x0080		/* lowest - parallel printer */
+ 
+ /*
+  * Interrupt Control offset into Interrupt descriptor table (IDT)
+  */
+ #define	ICU_OFFSET	32		/* 0-31 are processor exceptions */
+ #define	ICU_LEN		16		/* 32-47 are ISA interrupts */
+ 
+ #endif	__ICU__
